Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.struts2.util
Class ClassLoaderUtils

    java.lang.Object
      org.apache.struts2.util.ClassLoaderUtils

    public class ClassLoaderUtils

extends java.lang.Object

This class is extremely useful for loading resources and classes in a fault tolerant manner that works across different applications servers.

It has come out of many months of frustrating use of multiple application servers at Atlassian, please don't change things unless you're sure they're not going to break in one server or another!

Constructor Summary
`ClassLoaderUtils()`

Method Summary
`static java.net.URL` | `getResource(java.lang.String resourceName, java.lang.Class callingClass)` Load a given resource.
`static java.io.InputStream` | `getResourceAsStream(java.lang.String resourceName, java.lang.Class callingClass)` This is a convenience method to load a resource as a stream.
`static java.lang.Class` | `loadClass(java.lang.String className, java.lang.Class callingClass)` Load a class with a given name.
`static void` | `printClassLoader()` Prints the current classloader hierarchy - useful for debugging.
`static void` | `printClassLoader(java.lang.ClassLoader cl)` Prints the classloader hierarchy from a given classloader - useful for debugging.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ClassLoaderUtils

    public ClassLoaderUtils()

Method Detail

### getResource

    public static java.net.URL getResource(java.lang.String resourceName,
                                           java.lang.Class callingClass)

  Load a given resource.

  This method will try to load the resource using the following methods (in order):
  - From `Thread.currentThread().getContextClassLoader()`
  - From `ClassLoaderUtil.class.getClassLoader()`
  - From the `callingClass.getClassLoader()`

  Parameters:
    `resourceName` - The name of the resource to load
    `callingClass` - The Class object of the calling object

### getResourceAsStream

    public static java.io.InputStream getResourceAsStream(java.lang.String resourceName,
                                                          java.lang.Class callingClass)

  This is a convenience method to load a resource as a stream.

  The algorithm used to find the resource is given in getResource()

  Parameters:
    `resourceName` - The name of the resource to load
    `callingClass` - The Class object of the calling object

### loadClass

    public static java.lang.Class loadClass(java.lang.String className,
                                            java.lang.Class callingClass)
                                     throws java.lang.ClassNotFoundException

  Load a class with a given name.

  It will try to load the class in the following order:
  - From `Thread.currentThread().getContextClassLoader()`
  - Using the basic `Class.forName(java.lang.String)`
  - From `ClassLoaderUtil.class.getClassLoader()`
  - From the `callingClass.getClassLoader()`

  Parameters:
    `className` - The name of the class to load
    `callingClass` - The Class object of the calling object
  Throws:
    `java.lang.ClassNotFoundException` - If the class cannot be found anywhere.

### printClassLoader

    public static void printClassLoader()

  Prints the current classloader hierarchy - useful for debugging.

### printClassLoader

    public static void printClassLoader(java.lang.ClassLoader cl)

  Prints the classloader hierarchy from a given classloader - useful for debugging.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2011 Apache Software Foundation. All Rights Reserved.